﻿/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

using System;
using System.Collections.Generic;
using System.Text;
using moxa;

namespace DIO
{
    class Program
    {
        static void Main(string[] args)
        {
            int i = 0;
            int port = 0, value = 0, value2 = 0;
            string sdout = "";

            System.Console.WriteLine("Digitial In/Out Test Program");
            System.Console.WriteLine("\t (0) Exit Program");
            System.Console.WriteLine("\t (1) Display DIN");
            System.Console.WriteLine("\t (2) Display DOUT");
            System.Console.WriteLine("\t (3) Set DOUT value");
            System.Console.WriteLine("\t (4) Display both DIN and DOUT");

            // read a char.
            string sin = System.Console.ReadLine();
            int n = int.Parse(sin);

            moxa.v2420.dio dgio = new moxa.v2420.dio();
            if (!dgio.Open())
            {
                System.Console.WriteLine("Unable to open device.\n");
                return;
            }

            do
            {
                switch (n)
                {
                    // if char == '1', display the Din0 ~ Din5
                    case 1:
                        for (i = 0; i < 6; i++)
                        {
                            value = dgio.GetInputSignal(i);
                            System.Console.WriteLine("Din{0}={1}", i, value);
                        }
                        break;
                    // if char == '2', display the Dout0 ~ Dout1
                    case 2:
                        for (i = 0; i < 2; i++)
                        {
                            value = dgio.GetOutputSignal(i);
                            System.Console.WriteLine("DOut{0}={1}", i, value);
                        }
                        break;

                    // if char == '3', set DOUT value
                    case 3:
                        // read port Nnmber from console
                        System.Console.Write("Input the DOut Port Number (0 ~ 1) = ");
                        sdout = System.Console.ReadLine();
                        port = int.Parse(sdout);

                        // read port value from console
                        System.Console.Write("Input the DOut value (0 or 1) = ");
                        sdout = System.Console.ReadLine();
                        value = int.Parse(sdout);

                        System.Console.WriteLine("Set DOut{0}={1}", port, value);

                        if (value == 1)
                        {

                            // set the new value to the specified port
                            if (!dgio.SetOutputSignalHigh(port))
                            {
                                System.Console.WriteLine("SetOutputSignalHigh fail!");
                                break;
                            }
                        }
                        else
                        {
                            // set the new value to the specified port
                            if (!dgio.SetOutputSignalLow(port))
                            {
                                System.Console.WriteLine("SetOutputSignalLow fail!");
                                break;
                            }
                        }

                        break;

                    // if char == '4', display all of the Din and DOut value.
                    case 4:

                        for (i = 0; i < 6; i++)
                        {
                            //value = moxa.v2420.DigitalInput.Get(i);
                            value = dgio.GetInputSignal(i);
                            System.Console.Write("DIn{0}={1}",i,value);


                            value2 = dgio.GetOutputSignal(i);
                            if (value2 == -1)
                            {
                                System.Console.Write("\n");
                            }
                            else
                            {
                                System.Console.Write("  DOut{0}={1}\n", i, value2);
                            }
                            //System.Console.WriteLine("DIn{0}={1}  DOut{0}={2}", i, value, value2);
                        }
                        break;
                }
                sin = System.Console.ReadLine();
                n = int.Parse(sin);
            } while (n != 0);

            dgio.Close();
            dgio = null;
        }
    }
}
