/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

#include "stdafx.h"
#include <windows.h>
#include "mxwdg.h"

int _tmain(int argc, _TCHAR* argv[])
{
    int		hndFile;        // Handle to device, obtain from mxwdg_open
  	ULONG	time;
 
	/* starts watchdog timer*/
	time=10; //default is 10 secs
	if(argc > 1){
		time = _wtol(argv[1]);
		if(time > 255){
			printf("Invalid Parameter\n");
			return -1;
		}
	}
	hndFile=mxwdg_open(time);


    while ( TRUE )
	{
		printf( "Press \"ENTER\" in %d seconds\n, 'q' to exit",time);
		WCHAR ch = getwchar();
		if ( ch == (WCHAR)'q' )
		{
			break;
		}

		/* refresh watchdog timer*/
		mxwdg_refresh(hndFile);
	
	}

	/* stops watchdog timer*/
	mxwdg_close(hndFile);

	return 0;
}

